<div class="opening-times" *transloco="let t">
  <ng-container *ngIf="!openAllWeek; else openAllWeeks">
    <div class="regular-opening-times">
      <div
        *ngFor="let dayInfo of openingTimesWithSpecials"
        class="opening-times-col"
        [ngClass]="{
          'highlighted-opening-times': dayInfo.day === getCurrentDayOfWeek(),
          'opening-times-col-special': dayInfo.special,
        }"
      >
        <div class="special-opening-times-row">
          <div
            class="secondary-foreground-text"
            [ngClass]="{
              'changed-regular-opening-time-highlighted':
                dayInfo.special && dayInfo.day === getCurrentDayOfWeek(),
              'changed-regular-opening-time-non-highlighted day-regular':
                dayInfo.special && dayInfo.day !== getCurrentDayOfWeek(),
            }"
          >
            {{ t('ui.opening-times.' + dayInfo.day.toLowerCase()) }}
          </div>
          <div class="secondary-foreground-text">
            <ng-container
              *ngIf="isValidHours(dayInfo.regularHours); else closedBlock"
            >
              <ng-container *ngIf="dayInfo.special; else noSpecial">
                <del
                  [ngClass]="{
                    'highlighted-forground-text':
                      dayInfo.special && dayInfo.day === getCurrentDayOfWeek(),
                  }"
                >
                  <ng-container
                    *ngIf="
                      dayInfo.regularHours.from === '00:00:00' &&
                        dayInfo.regularHours.to === '23:59:00';
                      else displayRegular
                    "
                  >
                    {{ t('ui.opening-times.all_day') }}
                  </ng-container>
                  <ng-template #displayRegular>
                    {{ dayInfo.regularHours.from | timeFormat }} –
                    {{
                      t('ui.opening-times.to_time', {
                        time: dayInfo.regularHours.to | timeFormat,
                      })
                    }}
                  </ng-template>
                </del>
              </ng-container>
              <ng-template #noSpecial>
                <ng-container
                  *ngIf="
                    dayInfo.regularHours.from === '00:00:00' &&
                      dayInfo.regularHours.to === '23:59:00';
                    else displayRegularNoSpecial
                  "
                >
                  {{ t('ui.opening-times.all_day') }}
                </ng-container>
                <ng-template #displayRegularNoSpecial>
                  {{ dayInfo.regularHours.from | timeFormat }} –
                  {{
                    t('ui.opening-times.to_time', {
                      time: dayInfo.regularHours.to | timeFormat,
                    })
                  }}
                </ng-template>
              </ng-template>
            </ng-container>
            <ng-template #closedBlock>
              <ng-container *ngIf="dayInfo.special; else regularClosed">
                <del
                  [ngClass]="{
                    'highlighted-forground-text':
                      dayInfo.special && dayInfo.day === getCurrentDayOfWeek(),
                  }"
                >
                  {{ t('ui.opening-times.closed') }}
                </del>
              </ng-container>
              <ng-template #regularClosed>
                {{ t('ui.opening-times.closed') }}
              </ng-template>
            </ng-template>
          </div>
        </div>

        <div class="special-opening-times-row" *ngIf="dayInfo.special">
          <div class="secondary-foreground-text">
            <span
              [ngClass]="{
                'changed-regular-opening-time-highlighted':
                  dayInfo.special && dayInfo.day === getCurrentDayOfWeek(),
                'changed-regular-opening-time-non-highlighted day-description':
                  dayInfo.special && dayInfo.day !== getCurrentDayOfWeek(),
              }"
              >{{
                t('ui.opening-times.at', {
                  date: formatDateWithoutYear(dayInfo.date),
                })
              }}</span
            >
            <span
              class="changed-regular-opening-time-non-highlighted day-description"
              >{{ getSpecialDescription(dayInfo.special.descriptions) }}</span
            >
          </div>
          <div
            class="time"
            [ngClass]="{
              'changed-regular-opening-time-highlighted':
                dayInfo.special && dayInfo.day === getCurrentDayOfWeek(),
              'changed-regular-opening-time-non-highlighted day-regular':
                dayInfo.special && dayInfo.day !== getCurrentDayOfWeek(),
            }"
          >
            <ng-container
              *ngIf="
                dayInfo.special.from === '00:00:00' &&
                  dayInfo.special.to === '23:59:00';
                else displayTime
              "
            >
              {{ t('ui.opening-times.all_day') }}
            </ng-container>
            <ng-template #displayTime>
              <ng-container
                *ngIf="isValidHours(dayInfo.special); else specialClosed"
              >
                {{ dayInfo.special.from | timeFormat }} –
                {{
                  t('ui.opening-times.to_time', {
                    time: dayInfo.special.to | timeFormat,
                  })
                }}
              </ng-container>
              <ng-template #specialClosed>
                {{ t('ui.opening-times.closed') }}
              </ng-template>
            </ng-template>
          </div>
        </div>
      </div>
    </div>
  </ng-container>
  <ng-template #openAllWeeks>
    <div class="closed-block">
      <div class="text">{{ t('ui.opening-times.opened_all_day') }}</div>
    </div>
  </ng-template>
  <div
    *ngIf="futureSpecialOpeningTimes.length > 0"
    class="special-opening-times"
  >
    <div class="header">
      {{ t('ui.opening-times.next_special_opening_times') }}
    </div>
    <div
      class="opening-times-col"
      *ngFor="
        let special of futureSpecialOpeningTimes
          | slice
            : 0
            : (showAllSpecialTimes ? futureSpecialOpeningTimes.length : 2)
      "
    >
      <div class="special-opening-times-row">
        <div class="main-foreground-text">
          {{ special.date | date: 'dd.MM.yyyy' }}
        </div>
        <div class="time">
          <ng-container
            *ngIf="
              getRegularHoursForDate(special.date).from &&
                getRegularHoursForDate(special.date).to;
              else futureClosed
            "
          >
            <del class="main-foreground-text">
              <ng-container
                *ngIf="
                  getRegularHoursForDate(special.date).from === '00:00:00' &&
                    getRegularHoursForDate(special.date).to === '23:59:00';
                  else displayFutureRegular
                "
              >
                {{ t('ui.opening-times.all_day') }}
              </ng-container>
              <ng-template #displayFutureRegular>
                {{ getRegularHoursForDate(special.date).from | timeFormat }}
                –
                {{
                  t('ui.opening-times.to_time', {
                    time: getRegularHoursForDate(special.date).to | timeFormat,
                  })
                }}
              </ng-template>
            </del>
          </ng-container>
          <ng-template #futureClosed>
            <del>{{ t('ui.opening-times.closed') }}</del>
          </ng-template>
        </div>
      </div>

      <div class="special-opening-times-row">
        <div class="description">
          {{ getSpecialDescription(special.descriptions) }}
        </div>
        <div class="main-foreground-text">
          <ng-container
            *ngIf="
              special.from === '00:00:00' && special.to === '23:59:00';
              else displaySpecialTime
            "
          >
            {{ t('ui.opening-times.all_day') }}
          </ng-container>
          <ng-template #displaySpecialTime>
            <ng-container *ngIf="isValidHours(special); else specialClosed">
              {{ special.from | timeFormat }} –
              {{
                t('ui.opening-times.to_time', {
                  time: special.to | timeFormat,
                })
              }}
            </ng-container>
            <ng-template #specialClosed>
              {{ t('ui.opening-times.closed') }}
            </ng-template>
          </ng-template>
        </div>
      </div>
    </div>

    <div
      *ngIf="!showAllSpecialTimes && futureSpecialOpeningTimes.length > 2"
      class="special-opening-button-wrapper"
    >
      <lib-custom-horizontal-button
        (buttonClick)="showAllSpecialTimes = true"
        [buttonType]="customButtonType.button"
        [colorScheme]="customButtonColorScheme.hintSecondary"
        [title]="t('ui.opening-times.show_more')"
      >
      </lib-custom-horizontal-button>
    </div>

    <div
      *ngIf="showAllSpecialTimes && futureSpecialOpeningTimes.length > 2"
      class="special-opening-button-wrapper"
    >
      <lib-custom-horizontal-button
        (buttonClick)="showAllSpecialTimes = false"
        [buttonType]="customButtonType.button"
        [colorScheme]="customButtonColorScheme.hintSecondary"
        [title]="t('ui.opening-times.show_less')"
      >
      </lib-custom-horizontal-button>
    </div>
  </div>
</div>
